<?php
// ----------------------------------------------------------------------
// Copyright (c) 2002-2009 Shawn McKenzie
// http://www.spidean.com
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------

session_start();

$ER = 0;
error_reporting($ER);
$old_mask = umask(0);
chdir('../../');

define('BASEPATH', dirname(dirname(dirname(__FILE__))) . '/');
$oldthemepath = "themes/".$_POST['theme'];
$newthemepath = "themes/".$_POST['newtheme'];
$tmpthemepath = $oldthemepath.'_tmp';
$_SESSION['referer'] = $_SERVER['HTTP_REFERER'];

copydir(BASEPATH."modules/AutoConvert/tools/themes/AT-Example/", BASEPATH.$newthemepath);
copydir(BASEPATH.$oldthemepath, BASEPATH.$newthemepath, 0);

//make tmp dir and fix theme.php
copydir(BASEPATH.$oldthemepath, BASEPATH.$tmpthemepath);

$content = file_get_contents(BASEPATH."$tmpthemepath/theme.php");

$search = array (
	'/blocks\([\"\'](l|left)[\"\']\);/i',
	'/blocks\([\"\'](r|right)[\"\']\);/i',
	'/blocks\([\"\'](c|center|centre)[\"\']\);/i'
);

$replace = array (
	'echo "<!-- [left-blocks] -->";',
	'echo "<!-- [right-blocks] -->";',
	'echo "<!-- [center-blocks] -->";'
);

$content = preg_replace($search, $replace, $content);

$handle = fopen(BASEPATH."$tmpthemepath/theme.php", "w");
fwrite($handle, $content);
fclose($handle);

//include cms and theme
if ($handle = @opendir(BASEPATH."modules/AutoConvert/tools")) {
	while (false !== ($file = readdir($handle))) {
		if (ereg('platform-', $file)) {
			require_once(BASEPATH."modules/AutoConvert/tools/$file");
		}
	}
	closedir($handle);
}
error_reporting($ER);

//include config
include(BASEPATH."$newthemepath/theme.cfg");

//add colors
$style['default']['color1'] = $GLOBALS['bgcolor1'];
$style['default']['color2'] = $GLOBALS['bgcolor2'];
$style['default']['color3'] = $GLOBALS['bgcolor3'];
$style['default']['color4'] = $GLOBALS['bgcolor4'];
$style['default']['color5'] = $GLOBALS['textcolor1'];
$style['default']['color6'] = $GLOBALS['textcolor2'];

//create color commands
$GLOBALS['bgcolor1'] = "{color1}";
$GLOBALS['bgcolor2'] = "{color2}";
$GLOBALS['bgcolor3'] = "{color3}";
$GLOBALS['bgcolor4'] = "{color4}";
$GLOBALS['textcolor1'] = "{color5}";
$GLOBALS['textcolor2'] = "{color6}";

//create table1
$content = at_create_template('opentable');
$content .="<!-- [table-content] -->";
$content .= at_create_template('closetable');
at_save_template('table1.html', $content);

//create table2
$content = at_create_template('opentable2');
$content .="<!-- [table-content] -->";
$content .= at_create_template('closetable2');
at_save_template('table2.html', $content);

$block = array(
	'title' => '<!-- [block-title] -->',
	'content' => '<!-- [block-content] -->',
);
//create left block
$content = at_create_template('at_themesidebox', array($block));
at_save_template('leftblock.html', $content);

//create right block	
$content = at_create_template('at_themesidebox', array($block));
at_save_template('rightblock.html', $content);

//create center block
$content = at_create_template('at_themesidebox', array($block));
at_save_template('centerblock.html', $content);

//create area block
at_save_template('areablock.html', $content);

//create summary article
$args = at_build_news_commands('summary');

$content = at_create_template('themeindex', $args);
at_save_template('summary.html', $content);

//create full article
$args = at_build_news_commands('article');

$content = at_create_template('themearticle', $args);
at_save_template('article.html', $content);

//create main theme
$content = at_create_template('themeheader');

if (!stristr($content, "</head>")) {
	$content = "</head>" . $content;
}
$content = "<html>\n<head>\n" . $content;
$content .= "<!-- [modules] -->";
$content .= at_create_template('themefooter');

$content .= "\n<br />\n<div align=\"center\"><a href=\"http://www.spidean.com\"><img border=\"0\" src=\"{image-path}at-powered.gif\" alt=\"Powered by the AutoTheme HTML Theme System\"></a>\n";
$content .= "\n</body>\n</html>";
$content = trim($content);
at_save_template('theme.html', $content);

//fixup style sheets
if ($dir_handle = @opendir(BASEPATH."$newthemepath/style")) {
	while (false !== ($file = @readdir($dir_handle))) {
		if (false !== strpos('.css', $file)) {
			$content = file_get_contents(BASEPATH."$newthemepath/style/$file");
			$content = str_replace("$oldthemepath/", "$newthemepath/", $content);

			$handle = fopen(BASEPATH."$newthemepath/style/$file", "w");
			fwrite($handle, $content);
			fclose($handle);
		}
	}
	closedir($handle);
}

//save config
$content = "<?php\n"
.'$atversion = \'1.7\';'
."\n"
.'$template = '
.var_export((array)$template, TRUE)
.";\n"
.'$blockdisplay = '
.var_export((array)$blockdisplay, TRUE)
.";\n"
.'$style = '
.var_export((array)$style, TRUE)
.";\n"
.'$blocktemplate = '
.var_export((array)$blocktemplate, TRUE)
.";\n"
.'$autoblock = '
.var_export((array)$autoblock, TRUE)
.";\n"
.'$themecmd = '
.var_export((array)$themecmd, TRUE)
.";\n"
.'$blockcontrol = '
.var_export((array)$blockcontrol, TRUE)
.";\n?>";

$handle = fopen(BASEPATH."$newthemepath/theme.cfg", "w");
fwrite($handle, $content);
fclose($handle);

removedir(BASEPATH."$tmpthemepath/");

header("location: ".$_SESSION['referer']."&op=complete&themedir=".$_POST['newtheme']);
exit;

function removedir($current_dir)
{
   
        if($dir = @opendir($current_dir)) {
            while (($f = readdir($dir)) !== false) {
                if($f > '0' and filetype($current_dir.$f) == "file") {
                    unlink($current_dir.$f);
                } elseif($f > '0' and filetype($current_dir.$f) == "dir") {
                    removedir($current_dir.$f."/");
                }
            }
            closedir($dir);
            rmdir($current_dir);
        }
    }

function copydir($src, $dst, $root=1)
{
    $dir = opendir($src);
    @mkdir($dst);

    while(false !== ( $file = readdir($dir)) ) {
        if (($file != '.') && ( $file != '..')) {
            if (is_dir($src . '/' . $file) ) {
                copydir($src . '/' . $file, $dst . '/' . $file);
            } else {
                if($root > 0) {
					copy($src . '/' . $file, $dst . '/' . $file);
				}
            }
        }
    }
    closedir($dir);
}

function at_create_template($func, $args=array())
{
    ob_start();
    call_user_func_array($func, $args);
    $content = ob_get_contents();
    ob_end_flush();

	return $content;
}

function at_save_template($filename, $content)
{
	global $oldthemepath, $newthemepath;

    $content = str_replace("$oldthemepath/", "{theme-path}", $content);

    $handle = fopen(BASEPATH."$newthemepath/$filename", "w");
	fwrite($handle, $content);
	fclose($handle);
}

?>